SVN ist durcheinandergekommen bei Pfad-Anpassung Part 2 (Ende)
[ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3
MT
1#!/bin/bash
2#
3############################################################################
4# #
f8e5510c 5# This file is part of the IPFire Firewall. #
df5e82b3 6# #
f8e5510c 7# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
8# it under the terms of the GNU General Public License as published by #
9# the Free Software Foundation; either version 2 of the License, or #
10# (at your option) any later version. #
11# #
f8e5510c 12# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
13# but WITHOUT ANY WARRANTY; without even the implied warranty of #
14# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
15# GNU General Public License for more details. #
16# #
17# You should have received a copy of the GNU General Public License #
f8e5510c 18# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
19# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
20# #
f8e5510c 21# Copyright (C) 2006 IPFire-Team <entwickler@ipfire.org>. #
df5e82b3
MT
22# #
23############################################################################
df5e82b3
MT
24#
25
f8e5510c 26 NAME="IPFire" # Software name
3ea75603 27 SNAME="ipfire" # Short name
e3a8510a 28 VERSION="2.0" # Version number
028698e8 29 SLOGAN="www.ipfire.eu" # Software slogan
3ea75603 30 CONFIG_ROOT=/var/ipfire # Configuration rootdir
df5e82b3 31 NICE=10
0eab8e84 32 MAX_RETRIES=3 # prefetch/check loop
df5e82b3
MT
33 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
34 MACHINE=`uname -m`
cc0e56be 35 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
df5e82b3 36
7476f476
HS
37 # Setzen des IPFire Builds
38 if [ -e ./.svn ]; then
39 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
7476f476
HS
40 fi
41
df5e82b3
MT
42 # Debian specific settings
43 if [ ! -e /etc/debian_version ]; then
44 FULLPATH=`which $0`
45 else
46 if [ -x /usr/bin/realpath ]; then
47 FULLPATH=`/usr/bin/realpath $0`
48 else
49 echo "ERROR: Need to do apt-get install realpath"
50 exit 1
51 fi
52 fi
53
df5e82b3
MT
54 PWD=`pwd`
55 BASENAME=`basename $0`
56 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
57 LOGFILE=$BASEDIR/log/_build.preparation.log
58 export BASEDIR LOGFILE
59 DIR_CHK=$BASEDIR/cache/check
60 mkdir $BASEDIR/log/ 2>/dev/null
61
cc0e56be
MT
62 if [ -f .config ]; then
63 . .config
64 fi
65
df5e82b3 66 if [ 'x86_64' = $MACHINE -o 'i686' = $MACHINE -o 'i586' = $MACHINE -o 'i486' = $MACHINE -o 'i386' = $MACHINE ]; then
c6cb9d25 67 echo "`date -u '+%b %e %T'`: Machine is ix86 (or equivalent)" >> $LOGFILE
df5e82b3
MT
68 MACHINE=i386
69 BUILDTARGET=i386-pc-linux-gnu
70 CFLAGS="-O2 -mcpu=i386 -march=i386 -pipe -fomit-frame-pointer"
71 CXXFLAGS="-O2 -mcpu=i386 -march=i386 -pipe -fomit-frame-pointer"
72 elif [ 'alpha' = $MACHINE ]; then
c6cb9d25 73 echo "`date -u '+%b %e %T'`: Machine is Alpha AXP" >> $LOGFILE
df5e82b3
MT
74 BUILDTARGET=alpha-unknown-linux-gnu
75 CFLAGS="-O2 -mcpu=ev4 -mieee -pipe"
76 CXXFLAGS="-O2 -mcpu=ev4 -mieee -pipe"
77 else
c6cb9d25 78 echo "`date -u '+%b %e %T'`: Can't determine your architecture - $MACHINE" >> $LOGFILE
df5e82b3
MT
79 exit 1
80 fi
81
82# Define immediately
83stdumount() {
84 umount $BASEDIR/build/dev/pts 2>/dev/null;
94025eea
MT
85 umount $BASEDIR/build/proc 2>/dev/null;
86 umount $BASEDIR/build/install/mnt 2>/dev/null;
df5e82b3
MT
87 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
88 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
89 umount $BASEDIR/build/usr/src/config 2>/dev/null;
94025eea
MT
90 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
91 umount $BASEDIR/build/usr/src/html 2>/dev/null;
df5e82b3 92 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
94025eea
MT
93 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
94 umount $BASEDIR/build/usr/src/log 2>/dev/null;
95 umount $BASEDIR/build/usr/src/src 2>/dev/null;
df5e82b3
MT
96}
97
98exiterror() {
99 stdumount
100 for i in `seq 0 7`; do
101 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
102 losetup -d /dev/loop${i} 2>/dev/null
103 fi;
104 done
105 echo "ERROR: $*"
106 echo " Check $LOGFILE for errors if applicable"
107 exit 1
108}
109
110entershell() {
111 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
112 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
113 fi
114 echo "Entering to a shell inside LFS chroot, go out with exit"
115 chroot $LFS /tools/bin/env -i HOME=/root TERM=$TERM PS1='\u:\w\$ ' \
116 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin:/tools/bin \
117 VERSION=$VERSION CONFIG_ROOT=$CONFIG_ROOT \
118 NAME="$NAME" SNAME="$SNAME" SLOGAN="$SLOGAN" \
119 CFLAGS="$CFLAGS" CXXFLAGS="$CXXFLAGS" \
120 CCACHE_DIR=/usr/src/ccache \
121 CCACHE_HASHDIR=1 \
122 KVER=$KVER \
123 BUILDTARGET="$BUILDTARGET" MACHINE="$MACHINE" \
124 KGCC="ccache /usr/bin/gcc" \
125 /tools/bin/bash
126 if [ $? -ne 0 ]; then
127 exiterror "chroot error"
128 else
129 stdumount
130 fi
131}
132
133prepareenv() {
134 ############################################################################
135 # #
136 # Are we running the right shell? #
137 # #
138 ############################################################################
139 if [ ! "$BASH" ]; then
140 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
141 fi
142
143 if [ -z "${BASH_VERSION}" ]; then
144 exiterror "Not running BASH shell."
145 fi
146
147
148 ############################################################################
149 # #
150 # Trap on emergency exit #
151 # #
152 ############################################################################
153 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
154
155
156 ############################################################################
157 # #
158 # Resetting our nice level #
159 # #
160 ############################################################################
161 echo "`date -u '+%b %e %T'`: Resetting our nice level to $NICE" | tee -a $LOGFILE
162 renice $NICE $$ > /dev/null
163 if [ `nice` != "$NICE" ]; then
164 exiterror "Failed to set correct nice level"
165 fi
166
167 ############################################################################
168 # #
169 # Checking if running as root user #
170 # #
171 ############################################################################
172 echo "`date -u '+%b %e %T'`: Checking if we're running as root user" | tee -a $LOGFILE
173 if [ `id -u` != 0 ]; then
174 exiterror "Not building as root"
175 fi
176
177
178 ############################################################################
179 # #
180 # Checking for necessary temporary space #
181 # #
182 ############################################################################
183 echo "`date -u '+%b %e %T'`: Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
184 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
185 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
186 if (( 2202000 > $BASE_ASPACE )); then
187 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
188 if (( 2202000 - $BASE_USPACE > $BASE_ASPACE )); then
189 exiterror "Not enough temporary space available, need at least 2.1GB on $BASE_DEV"
190 fi
191 fi
192
193 ############################################################################
194 # #
195 # Building Linux From Scratch system #
196 # #
197 ############################################################################
198 echo "`date -u '+%b %e %T'`: Building Linux From Scratch system" | tee -a $LOGFILE
199
200 # Set umask
201 umask 022
202
203 # Set LFS Directory
204 LFS=$BASEDIR/build
205
206 # Check /tools symlink
207 if [ -h /tools ]; then
208 rm -f /tools
209 fi
210 if [ ! -a /tools ]; then
211 ln -s $BASEDIR/build/tools /
212 fi
213 if [ ! -h /tools ]; then
214 exiterror "Could not create /tools symbolic link."
215 fi
216
217 # Setup environment
218 set +h
219 LC_ALL=POSIX
220 export LFS LC_ALL CFLAGS CXXFLAGS
221 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
222
223 # Make some extra directories
224 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
225 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
226 mkdir -p $BASEDIR/build/dev/pts $BASEDIR/build/proc $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
227
228 # Make all sources and proc available under lfs build
229 mount --bind /dev/pts $BASEDIR/build/dev/pts
230 mount --bind /proc $BASEDIR/build/proc
231 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
232 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
233 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
234 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
235 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
236 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
237 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
238 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
239 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
240
241 # Run LFS static binary creation scripts one by one
242 export CCACHE_DIR=$BASEDIR/ccache
243 export CCACHE_HASHDIR=1
244
245 # Remove pre-install list of installed files in case user erase some files before rebuild
246 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
247}
248
249
250############################################################################
251# #
252# Necessary shell functions #
253# #
254############################################################################
255lfsmake1() {
256 if [ -f $BASEDIR/lfs/$1 ]; then
257 echo "`date -u '+%b %e %T'`: Building $*" | tee -a $LOGFILE
258 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR MESSAGE="$1\t " download >> $LOGFILE 2>&1
259 if [ $? -ne 0 ]; then
260 exiterror "Download error in $1"
261 fi
262 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
263 if [ $? -ne 0 ]; then
264 exiterror "md5sum error in $1, check file in cache or signature"
265 fi
266 cd $BASEDIR/lfs && make -f $* BUILDTARGET=$BUILDTARGET \
267 MACHINE=$MACHINE \
268 LFS_BASEDIR=$BASEDIR \
269 ROOT=$LFS \
270 KVER=$KVER \
271 install >> $LOGFILE 2>&1
272 if [ $? -ne 0 ]; then
273 exiterror "Building $*";
274 fi
275 else
276 exiterror "No such file or directory: $BASEDIR/$1"
277 fi
278 return 0
279}
280
281lfsmake2() {
282 if [ -f $BASEDIR/build/usr/src/lfs/$1 ]; then
283 echo "`date -u '+%b %e %T'`: Building $*" | tee -a $LOGFILE
284 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR MESSAGE="$1\t " download >> $LOGFILE 2>&1
285 if [ $? -ne 0 ]; then
286 exiterror "Download error in $1"
287 fi
288 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
289 if [ $? -ne 0 ]; then
290 exiterror "md5sum error in $1, check file in cache or signature"
291 fi
292 chroot $LFS /tools/bin/env -i HOME=/root \
293 TERM=$TERM PS1='\u:\w\$ ' \
294 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin:/tools/bin \
295 VERSION=$VERSION \
296 CONFIG_ROOT=$CONFIG_ROOT \
297 NAME="$NAME" SNAME="$SNAME" SLOGAN="$SLOGAN" \
298 CFLAGS="$CFLAGS" CXXFLAGS="$CXXFLAGS" \
299 CCACHE_DIR=/usr/src/ccache CCACHE_HASHDIR=1 \
300 KVER=$KVER \
301 BUILDTARGET="$BUILDTARGET" MACHINE="$MACHINE" \
302 /tools/bin/bash -x -c "cd /usr/src/lfs && \
303 make -f $* LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
304 if [ $? -ne 0 ]; then
305 exiterror "Building $*"
306 fi
307 else
308 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/$1"
309 fi
310 return 0
311}
312
313ipcopmake() {
314 if [ -f $BASEDIR/build/usr/src/lfs/$1 ]; then
315 echo "`date -u '+%b %e %T'`: Building $*" | tee -a $LOGFILE
316 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR MESSAGE="$1\t " download >> $LOGFILE 2>&1
317 if [ $? -ne 0 ]; then
318 exiterror "Download error in $1"
319 fi
320 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
321 if [ $? -ne 0 ]; then
322 exiterror "md5sum error in $1, check file in cache or signature"
323 fi
324 chroot $LFS /tools/bin/env -i HOME=/root \
325 TERM=$TERM PS1='\u:\w\$ ' \
326 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
327 VERSION=$VERSION \
328 CONFIG_ROOT=$CONFIG_ROOT \
329 NAME="$NAME" SNAME="$SNAME" SLOGAN="$SLOGAN" \
330 CFLAGS="$CFLAGS" CXXFLAGS="$CXXFLAGS" \
331 CCACHE_DIR=/usr/src/ccache CCACHE_HASHDIR=1 \
332 KVER=$KVER \
333 BUILDTARGET="$BUILDTARGET" MACHINE="$MACHINE" \
334 /bin/bash -x -c "cd /usr/src/lfs && \
335 make -f $* LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
336 if [ $? -ne 0 ]; then
337 exiterror "Building $*"
338 fi
339 else
340 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/$1"
341 fi
342 return 0
343}
344
e7164bb4
MT
345ipfiredist() {
346 if [ -f $BASEDIR/build/usr/src/lfs/$1 ]; then
913668ba 347# if [ ! `ls -w1 $BASEDIR/packages/*.ipfire | grep $1` ]; then
e7164bb4 348 echo "`date -u '+%b %e %T'`: Packaging $1" | tee -a $LOGFILE
e7164bb4
MT
349 chroot $LFS /tools/bin/env -i HOME=/root \
350 TERM=$TERM PS1='\u:\w\$ ' \
351 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
352 VERSION=$VERSION \
353 CONFIG_ROOT=$CONFIG_ROOT \
354 NAME="$NAME" SNAME="$SNAME" SLOGAN="$SLOGAN" \
355 CFLAGS="$CFLAGS" CXXFLAGS="$CXXFLAGS" \
356 CCACHE_DIR=/usr/src/ccache CCACHE_HASHDIR=1 \
357 KVER=$KVER \
358 BUILDTARGET="$BUILDTARGET" MACHINE="$MACHINE" \
359 /bin/bash -x -c "cd /usr/src/lfs && \
360 make -f $1 LFS_BASEDIR=/usr/src dist" >>$LOGFILE 2>&1
361 if [ $? -ne 0 ]; then
362 exiterror "Packaging $1"
363 fi
a68fedca
MT
364# else
365# echo "`date -u '+%b %e %T'`: Packaging: The package $1 already exists"
366# fi
e7164bb4
MT
367 else
368 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/$1"
369 fi
e7164bb4
MT
370 return 0
371}
372
df5e82b3
MT
373
374installmake() {
375 if [ -f $BASEDIR/build/usr/src/lfs/$1 ]; then
376 echo "`date -u '+%b %e %T'`: Building $*" | tee -a $LOGFILE
377 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR MESSAGE="$1\t " download >> $LOGFILE 2>&1
378 if [ $? -ne 0 ]; then
379 exiterror "Download error in $1"
380 fi
381 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
382 if [ $? -ne 0 ]; then
383 exiterror "md5sum error in $1, check file in cache or signature"
384 fi
385 chroot $LFS /tools/bin/env -i HOME=/root \
386 TERM=$TERM PS1='\u:\w\$ ' \
387 PATH=/usr/local/bin:/opt/$MACHINE-uClibc/usr/bin:/bin:/usr/bin:/sbin:/usr/sbin \
388 VERSION=$VERSION \
389 CONFIG_ROOT=$CONFIG_ROOT \
390 LFS_PASS="install" \
391 NAME="$NAME" SNAME="$SNAME" SLOGAN="$SLOGAN" \
392 CFLAGS="-Os" CXXFLAGS="-Os" \
393 CCACHE_DIR=/usr/src/ccache CCACHE_HASHDIR=1 \
394 KVER=$KVER \
395 BUILDTARGET="$BUILDTARGET" MACHINE="$MACHINE" \
396 /bin/bash -x -c "cd /usr/src/lfs && \
397 make -f $* LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
398 if [ $? -ne 0 ]; then
399 exiterror "Building $*"
400 fi
401 else
402 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/$1"
403 fi
404 return 0
405}
406
407buildtoolchain() {
408 LOGFILE="$BASEDIR/log/_build.toolchain.log"
409 export LOGFILE
410 echo -ne "`date -u '+%b %e %T'`: Stage1 toolchain build \n" | tee -a $LOGFILE
411 # Build sed now, as we use some extensions
412 ORG_PATH=$PATH
413 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
414 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
415 lfsmake1 ccache
416 lfsmake1 sed LFS_PASS=1
417 lfsmake1 m4 LFS_PASS=1
418 lfsmake1 bison LFS_PASS=1
419 lfsmake1 flex LFS_PASS=1
420 lfsmake1 binutils LFS_PASS=1
421 lfsmake1 gcc LFS_PASS=1
422 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
423
424 lfsmake1 linux
425 lfsmake1 tcl
426 lfsmake1 expect
427 lfsmake1 glibc
428 lfsmake1 dejagnu
429 lfsmake1 gcc LFS_PASS=2
430 lfsmake1 binutils LFS_PASS=2
431 lfsmake1 gawk
432 lfsmake1 coreutils
433 lfsmake1 bzip2
434 lfsmake1 gzip
435 lfsmake1 diffutils
436 lfsmake1 findutils
437 lfsmake1 make
438 lfsmake1 grep
439 lfsmake1 sed LFS_PASS=2
440 lfsmake1 m4 LFS_PASS=2
441 lfsmake1 bison LFS_PASS=2
442 lfsmake1 flex LFS_PASS=2
443 lfsmake1 gettext
444 lfsmake1 ncurses
445 lfsmake1 patch
446 lfsmake1 tar
447 lfsmake1 texinfo
448 lfsmake1 bash
449 lfsmake1 util-linux
450 lfsmake1 perl
451 export PATH=$ORG_PATH
452}
453
454buildbase() {
455 LOGFILE="$BASEDIR/log/_build.base.log"
456 export LOGFILE
457 echo -ne "`date -u '+%b %e %T'`: Stage2 linux base build \n" | tee -a $LOGFILE
458 # Run LFS dynamic binary creation scripts one by one
459 lfsmake2 stage2
460 lfsmake2 makedev
461 lfsmake2 linux
462 lfsmake2 man-pages
463 lfsmake2 glibc
464 lfsmake2 binutils
465 lfsmake2 gcc
466 lfsmake2 coreutils
467 lfsmake2 zlib
468 lfsmake2 mktemp
469 lfsmake2 iana-etc
470 lfsmake2 findutils
471 lfsmake2 gawk
472 lfsmake2 ncurses
473 lfsmake2 vim
474 lfsmake2 m4
475 lfsmake2 bison
476 lfsmake2 less
477 lfsmake2 groff
478 lfsmake2 sed
479 lfsmake2 flex
480 lfsmake2 gettext
481 lfsmake2 net-tools
482 lfsmake2 inetutils
483 lfsmake2 perl
484 lfsmake2 texinfo
485 lfsmake2 autoconf
486 lfsmake2 automake
487 lfsmake2 bash
488 lfsmake2 file
489 lfsmake2 libtool
490 lfsmake2 bzip2
491 lfsmake2 diffutils
492 lfsmake2 ed
493 lfsmake2 kbd
494 lfsmake2 e2fsprogs
495 lfsmake2 grep
496 if [ 'i386' = $MACHINE ]; then
497 lfsmake2 grub
498 elif [ 'alpha' = $MACHINE ]; then
499 lfsmake2 aboot
500 fi
501 lfsmake2 gzip
502 lfsmake2 man
503 lfsmake2 make
504 lfsmake2 modutils
505 lfsmake2 patch
506 lfsmake2 procinfo
507 lfsmake2 procps
508 lfsmake2 psmisc
509 lfsmake2 shadow
510 lfsmake2 sysklogd
511 lfsmake2 sysvinit
512 lfsmake2 tar
513 lfsmake2 util-linux
514}
515
516buildipcop() {
907cd036
MT
517 # Run IPFire make scripts one by one
518 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3
MT
519 export LOGFILE
520 echo -ne "`date -u '+%b %e %T'`: Stage3 $NAME build \n" | tee -a $LOGFILE
521
522 # Build these first as some of the kernel packages below rely on
523 # these for some of their client program functionality
524 ipcopmake configroot
525 ipcopmake dhcp
526 ipcopmake dhcpcd
527 ipcopmake libusb
528 ipcopmake libpcap
529 ipcopmake linux-atm
530 ipcopmake ppp
531 ipcopmake rp-pppoe
532 ipcopmake unzip
533 # Do SMP now
534 if [ 'i386' = $MACHINE ]; then
535 # abuse the SMP flag, and make an minimal installer kernel first
536 # so that the boot floppy always works.....
3e45cc09
MT
537 ipcopmake linux LFS_PASS=ipfire SMP=installer
538 ipcopmake linux LFS_PASS=ipfire SMP=1
df5e82b3
MT
539 ipcopmake 3cp4218 SMP=1
540 ipcopmake amedyn SMP=1
541 ipcopmake cxacru SMP=1
542 ipcopmake eagle SMP=1
543
544 # These are here because they have i386 only binary libraries
545 # included in the package.
546 ipcopmake cnx_pci SMP=1
547 ipcopmake fcdsl SMP=1
548 ipcopmake fcdsl2 SMP=1
549 ipcopmake fcdslsl SMP=1
550 ipcopmake fcdslusb SMP=1
551 ipcopmake fcdslslusb SMP=1
6ca65b88 552 ipcopmake fcpci SMP=1
ff7df9d4 553 ipcopmake fcclassic SMP=1
df5e82b3
MT
554 ipcopmake pulsar SMP=1
555 ipcopmake unicorn SMP=1
1fde937c 556 ipcopmake promise-sata-300-tx SMP=1
df5e82b3
MT
557 fi
558
3e45cc09 559 ipcopmake linux LFS_PASS=ipfire
df5e82b3
MT
560 ipcopmake 3cp4218
561 ipcopmake amedyn
562 ipcopmake cxacru
563 ipcopmake eciadsl
564 ipcopmake eagle
565 ipcopmake speedtouch
566 if [ 'i386' = $MACHINE ]; then
567 # These are here because they have i386 only binary libraries
568 # included in the package.
569 ipcopmake cnx_pci
570 ipcopmake fcdsl
571 ipcopmake fcdsl2
572 ipcopmake fcdslsl
573 ipcopmake fcdslusb
6ca65b88 574 ipcopmake fcdslslusb
ff7df9d4
MT
575 ipcopmake fcpci
576 ipcopmake fcclassic
1fde937c
MT
577 ipcopmake pulsar
578 ipcopmake unicorn
579 ipcopmake promise-sata-300-tx
df5e82b3
MT
580 fi
581
582 ipcopmake pcmcia-cs
583 ipcopmake expat
584 ipcopmake gdbm
585 ipcopmake gmp
586 ipcopmake openssl
587 ipcopmake python
588 ipcopmake libnet
589 ipcopmake libpng
2ae94d2d
MT
590 ipcopmake libtiff
591 ipcopmake libjpeg
592 ipcopmake lcms
593 ipcopmake libmng
594 ipcopmake freetype
df5e82b3
MT
595 ipcopmake gd
596 ipcopmake popt
597 ipcopmake slang
598 ipcopmake newt
599 ipcopmake libcap
600 ipcopmake pciutils
601 ipcopmake pcre
7b6b8153 602 ipcopmake readline
048123a8 603 ipcopmake libxml2
f4509bca
MT
604 ipcopmake berkeley
605 ipcopmake BerkeleyDB ## The Perl module
606 ipcopmake mysql
7b6b8153
MT
607 ipcopmake saslauthd PASS=1
608 ipcopmake openldap
1658f920 609 #ipcopmake apache
7b6b8153
MT
610 ipcopmake apache2
611 ipcopmake php
df5e82b3
MT
612 ipcopmake arping
613 ipcopmake beep
614 ipcopmake bind
615 ipcopmake capi4k-utils
616 ipcopmake cdrtools
617 ipcopmake dnsmasq
618 ipcopmake dosfstools
619 ipcopmake ethtool
620 ipcopmake ez-ipupdate
621 ipcopmake fcron
622 ipcopmake perl-GD
623 ipcopmake gnupg
624 ipcopmake hdparm
625 ipcopmake ibod
626 ipcopmake initscripts
627 ipcopmake iptables
628 ipcopmake ipac-ng
629 ipcopmake ipaddr
630 ipcopmake iproute2
631 ipcopmake iptstate
632 ipcopmake iputils
78331e30 633 ipcopmake l7-protocols
df5e82b3
MT
634 ipcopmake isapnptools
635 ipcopmake isdn4k-utils
636 ipcopmake kudzu
637 ipcopmake logrotate
638 ipcopmake logwatch
639 ipcopmake mingetty
640 ipcopmake misc-progs
641 ipcopmake mtools
642 ipcopmake nano
643 ipcopmake nash
644 ipcopmake nasm
645 ipcopmake URI
646 ipcopmake HTML-Tagset
647 ipcopmake HTML-Parser
648 ipcopmake Compress-Zlib
649 ipcopmake Digest
650 ipcopmake Digest-SHA1
651 ipcopmake Digest-HMAC
652 ipcopmake libwww-perl
653 ipcopmake Net-DNS
654 ipcopmake Net-IPv4Addr
655 ipcopmake Net_SSLeay
4f8b6695
MT
656 ipcopmake IO-Stringy
657 ipcopmake Unix-Syslog
658 ipcopmake Mail-Tools
659 ipcopmake MIME-Tools
660 ipcopmake Net-Server
661 ipcopmake Convert-TNEF
662 ipcopmake Convert-UUlib
663 ipcopmake Archive-Tar
664 ipcopmake Archive-Zip
f28d0ddc 665 ipcopmake Text-Tabs+Wrap
90350ff3 666 ipcopmake Locale-Country
dace10b5 667 ipcopmake GeoIP
df8c7810 668 ipcopmake fwhits
df5e82b3
MT
669 ipcopmake noip_updater
670 ipcopmake ntp
671 ipcopmake oinkmaster
672 ipcopmake openssh
673 ipcopmake openswan
674 ipcopmake pptpclient
675 ipcopmake rrdtool
676 ipcopmake setserial
677 ipcopmake setup
678 ipcopmake snort
679 #ipcopmake speedycgi
680 ipcopmake squid
681 ipcopmake squid-graph
60cbd6e7 682 ipcopmake squidguard
df5e82b3
MT
683 ipcopmake tcpdump
684 ipcopmake traceroute
685 ipcopmake vlan
0145f271 686 ipcopmake wireless
df5e82b3
MT
687 ipcopmake libsafe
688 ipcopmake 3c5x9setup
894c6feb 689# echo -ne "`date -u '+%b %e %T'`: Building ### IPFire modules ### \n" | tee -a $LOGFILE
b34fd95d 690 ipcopmake pakfire
6ef0bff8 691 ipcopmake startscripts
5e69ef1a 692## Zuerst die Libs und dann die Programme. Ordnung muss sein!
6ef0bff8 693 ipcopmake java
a7b1824c 694 ipcopmake bootsplash
5e69ef1a
MT
695 ipcopmake spandsp
696 ipcopmake lzo
6ef0bff8 697 ipcopmake openvpn
f8e5510c
MT
698 ipcopmake pkg-config
699 ipcopmake glib
180cd3be 700 ipcopmake xampp
5e69ef1a
MT
701 ipcopmake pam
702 ipcopmake pammysql
371d9df0 703 ipcopmake saslauthd PASS=2
a31b2bc4 704 ipcopmake xinetd
316160b0
MT
705 ipcopmake ghostscript
706 ipcopmake cups
b34fd95d 707# ipcopmake lpd ## Im Moment aus, da CUPS vorhanden ist.
98d413ac 708 ipcopmake samba
5e69ef1a
MT
709 ipcopmake sudo
710 ipcopmake mc
40a4ea4c
MT
711# ipcopmake pwlib
712# ipcopmake openh323
1fe6c87b 713 ipcopmake wget
60cbd6e7 714 ipcopmake wput
1fe6c87b 715 ipcopmake bridge-utils
3e45cc09
MT
716 ipcopmake screen
717 ipcopmake hddtemp
1fde937c 718 ipcopmake smartmontools
3e45cc09
MT
719 ipcopmake htop
720 ipcopmake lynx
b34fd95d 721 echo -ne "`date -u '+%b %e %T'`: Building ### Mailserver ### \n" | tee -a $LOGFILE
94025eea 722 ipcopmake postfix
6c666a3b 723 ipcopmake procmail
93dc5548
MT
724 ipcopmake fetchmail
725 ipcopmake cyrusimap
f28d0ddc 726 ipcopmake web-cyradm
33a31f1a 727 ipcopmake mailx
f9315063
MT
728 ipcopmake clamav
729 ipcopmake razor
4f8b6695 730 ipcopmake spamassassin
f28d0ddc 731# ipcopmake amavisd
b34fd95d 732 echo -ne "`date -u '+%b %e %T'`: Building ### VoIP-Server ### \n" | tee -a $LOGFILE
94025eea 733 ipcopmake stund
b684b13b
MT
734 ipcopmake zaptel
735 ipcopmake libpri
736 ipcopmake bristuff
40a4ea4c 737 ipcopmake asterisk
894c6feb 738 ipcopmake mpg123
d1b6aa72 739 echo -ne "`date -u '+%b %e %T'`: Building ### Multimedia-Server ### \n" | tee -a $LOGFILE
8a7ededb 740 ipcopmake libmad
5ac2da9f
MT
741 ipcopmake libogg
742 ipcopmake libvorbis
316160b0 743 ipcopmake lame
d1b6aa72
MT
744 ipcopmake xvid
745 ipcopmake mpeg2dec
746 ipcopmake ffmpeg
5ac2da9f 747 ipcopmake sox
316160b0 748 ipcopmake gnump3d
d1b6aa72 749 ipcopmake videolan
6ef0bff8
MT
750 echo -ne "`date -u '+%b %e %T'`: Building ### P2P-Clients ### \n" | tee -a $LOGFILE
751 ipcopmake applejuice
02dc0a76
MT
752 ipcopmake ocaml
753 ipcopmake mldonkey
754# ipcopmake edonkeyclc
894c6feb 755# ipcopmake sane
3e45cc09
MT
756 echo -ne "`date -u '+%b %e %T'`: Building ### Net-Tools ### \n" | tee -a $LOGFILE
757 ipcopmake ntop
894c6feb 758# ipcopmake rsync
3b9f6349 759 ipcopmake tcpwrapper
769a61c5 760 ipcopmake portmap
894c6feb 761 ipcopmake nfs
907cd036 762 ipcopmake nmap
52345790 763 ipcopmake mbmon
3e45cc09 764 ipcopmake iftop
ef05c8bb 765 ipcopmake ncftp
ca35618d 766 ipcopmake cftp
60cbd6e7 767 ipcopmake etherwake
33a31f1a 768 ipcopmake ethereal
712d859c 769 ipcopmake tftp-hpa
a6b08d93 770 #ipcopmake subversion
7a98bae5 771 ipcopmake iptraf
2ae94d2d 772 ipcopmake nagios
0145f271 773 ipcopmake yasuc
0eab8e84 774# ipcopmake stunnel # Ausgeschaltet, weil wir es doch nicht nutzen
df5e82b3
MT
775}
776
777buildinstaller() {
778 # Run installer scripts one by one
779 LOGFILE="$BASEDIR/log/_build.installer.log"
780 export LOGFILE
781 echo -ne "`date -u '+%b %e %T'`: Stage4 installer build \n" | tee -a $LOGFILE
782 if [ 'i386' = $MACHINE ]; then
783 ipcopmake syslinux
784 ipcopmake as86
785 ipcopmake mbr
786 ipcopmake uClibc
787 fi
788 installmake busybox
789 installmake sysvinit
790 installmake e2fsprogs
791 installmake misc-progs
792 installmake slang
793 installmake util-linux
794 installmake newt
795 installmake pciutils
796 installmake pcmcia-cs
797 installmake kbd
798 installmake installer
799 installmake scsi.img
800 installmake driver.img
801 installmake initrd
802 installmake boot.img
803}
804
805buildpackages() {
806 LOGFILE="$BASEDIR/log/_build.packages.log"
807 export LOGFILE
808 echo "... see detailed log in _build.*.log files" >> $LOGFILE
809 echo -ne "`date -u '+%b %e %T'`: Stage5 packages build \n" | tee -a $LOGFILE
810 # Strip files
811 echo "`date -u '+%b %e %T'`: Stripping files" | tee -a $LOGFILE
812 find $LFS/lib $LFS/usr/lib $LFS/usr/share/rrdtool-* $LFS/install ! -type l \( -name '*.so' -o -name '*.so[\.0-9]*' \) \
813 ! -name 'libc.so' ! -name 'libpthread.so' ! -name 'libcrypto.so.0.9.7.sha1' \
90350ff3 814 -exec $LFS/tools/bin/strip --strip-all {} \; >> $LOGFILE 2>&1
df5e82b3
MT
815 # add -ls before -exec if you want to verify what files are stripped
816
817 find $LFS/{,s}bin $LFS/usr/{,s}bin $LFS/usr/local/{,s}bin ! -type l \
818 -exec file {} \; | grep " ELF " | cut -f1 -d ':' | xargs $LFS/tools/bin/strip --strip-all >> $LOGFILE 2>&1
819 # there add -v to strip to verify
820
821 if [ 'i386' = $MACHINE ]; then
822 # Create fcdsl packages
823 echo "`date -u '+%b %e %T'`: Building fcdsl tgz" | tee -a $LOGFILE
824 cp $LFS/install/images/fcdsl/license.txt $LFS >> $LOGFILE 2>&1
825 touch $LFS/var/run/{need-depmod-$KVER,need-depmod-$KVER-smp}
826 cd $LFS && tar cvfz $LFS/install/images/$SNAME-fcdsl-$VERSION.$MACHINE.tgz \
827 lib/modules/$KVER/misc/fcdsl*.o.gz \
828 lib/modules/$KVER-smp/misc/fcdsl*.o.gz \
829 usr/lib/isdn/{fds?base.bin,fd?ubase.frm} \
830 etc/fcdsl/fcdsl*.conf \
831 etc/drdsl/{drdsl,drdsl.ini} \
832 license.txt \
833 var/run/{need-depmod-$KVER,need-depmod-$KVER-smp} >> $LOGFILE 2>&1
834 rm -f $LFS/license.txt >> $LOGFILE 2>&1
835 cd $BASEDIR
836 fi
df5e82b3
MT
837
838 # Generating list of packages used
839 echo "`date -u '+%b %e %T'`: Generating packages list from logs" | tee -a $LOGFILE
840 rm -f $BASEDIR/doc/packages-list
841 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
842 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
3ea75603 843 echo " * `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
844 fi
845 done
3ea75603 846 echo "====== List of softwares used to build $NAME Version: $VERSION ======" > $BASEDIR/doc/packages-list.txt
712d859c 847 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|ipfire$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|^ipfire-logs' \
df5e82b3
MT
848 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
849 rm -f $BASEDIR/doc/packages-list
c9673262 850 # packages-list.txt is ready to be displayed for wiki page
df5e82b3
MT
851
852 # Create ISO for CDRom and USB-superfloppy
c3defe9b 853 ipcopmake cdrom
e67a57fe 854 rm -f $LFS/install/images/*usb*
c3defe9b 855 cp $LFS/install/images/{*.iso,*.tgz} $BASEDIR >> $LOGFILE 2>&1
c9673262 856
e67a57fe
MT
857 ipfirepackages
858
859 # Cleanup
860 stdumount
861 rm -rf $BASEDIR/build/tmp/*
862
863 # Generating total list of files
864 echo "`date -u '+%b %e %T'`: Generating files list from logs" | tee -a $LOGFILE
865 rm -f $BASEDIR/log/FILES
866 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
867 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
868 echo "##" >>$BASEDIR/log/FILES
869 echo "## `basename $i`" >>$BASEDIR/log/FILES
870 echo "##" >>$BASEDIR/log/FILES
871 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
872 fi
873 done
913668ba 874 cd $BASEDIR/packages; ls -w1 *.ipfire | awk -F ".ipfire" '{ print $1 }' > $BASEDIR/packages/packages_list.txt
5e773594 875 echo -n "###EOF###" >> $BASEDIR/packages/packages_list.txt
e67a57fe
MT
876
877 cd $PWD
878
879}
880
881ipfirepackages() {
013a23e2
MT
882 if [ -d "$BASEDIR/packages" ]; then
883 for i in `ls $BASEDIR/packages`; do
884 touch $BASEDIR/build/install/packages/$i.empty
885 done
886 fi
f0ca8c34 887 ipfiredist amavisd
78331e30 888 ipfiredist applejuice
5ac2da9f 889 ipfiredist asterisk
c7acba4a 890 ipfiredist clamav
483f59cd 891 ipfiredist cups
78331e30
MT
892 ipfiredist cyrusimap
893 ipfiredist fetchmail
d1b6aa72 894 ipfiredist ffmpeg
78331e30 895 ipfiredist gnump3d
7a98bae5 896 ipfiredist iptraf
0d0521b6 897 ipfiredist java
78331e30 898 ipfiredist lame
d1b6aa72 899 ipfiredist libmad
ae179f6e 900 ipfiredist libogg
78331e30 901 ipfiredist libtiff
ae179f6e 902 ipfiredist libvorbis
78331e30 903 ipfiredist libxml2
f0ca8c34 904 ipfiredist mailx
3ab910dd 905 ipfiredist mldonkey
d1b6aa72 906 ipfiredist mpeg2dec
2ae94d2d 907 ipfiredist nagios
f0ca8c34
MT
908 ipfiredist nfs
909 ipfiredist nmap
3e45cc09 910 ipfiredist ntop
27ac55bf 911 ipfiredist portmap
78331e30 912 ipfiredist postfix
371d9df0 913 ipfiredist procmail
90350ff3 914 ipfiredist samba
ae179f6e 915 ipfiredist sox
f0ca8c34 916 ipfiredist spamassassin
7a98bae5 917 ipfiredist subversion
d1b6aa72 918 ipfiredist videolan
f28d0ddc 919 ipfiredist web-cyradm
483f59cd 920 ipfiredist xampp
43f8b5f1 921# ipfiredist xinetd
d1b6aa72 922 ipfiredist xvid
0145f271 923 ipfiredist yasuc
78331e30 924 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
d535503d 925 mv -f $LFS/install/packages/*.{ipfire,md5} $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 926 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
927}
928
cc0e56be
MT
929update_logs() {
930 tar cfz log/ipfire-logs-`date +'%Y-%m-%d-%H:%M'`.tgz log/_build.*
931 rm -f log/_build.*
932}
933
df5e82b3
MT
934# See what we're supposed to do
935case "$1" in
936build)
937 BUILDMACHINE=`uname -m`
712d859c 938 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
df5e82b3
MT
939 #only restore on a clean disk
940 if [ ! -f log/perl-*-tools ]; then
941 if [ ! -n "$PACKAGE" ]; then
942 echo "`date -u '+%b %e %T'`: Full toolchain compilation" | tee -a $LOGFILE
943 prepareenv
944 buildtoolchain
945 else
946 PACKAGENAME=${PACKAGE%.tar.gz}
947 echo "`date -u '+%b %e %T'`: Restore from $PACKAGE" | tee -a $LOGFILE
948 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
949 tar zxf $PACKAGE
950 prepareenv
951 else
952 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
953 fi
954 fi
955 else
956 echo "`date -u '+%b %e %T'`: Using installed toolchain" | tee -a $LOGFILE
957 prepareenv
958 fi
5cfe86e6 959
df5e82b3
MT
960 buildbase
961 buildipcop
5cfe86e6
HS
962
963 # Setzen des IPFire Builds
8af06406 964 if [ "$FIREBUILD" ]; then
e57bc1fd 965 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
5cfe86e6 966 else
e57bc1fd 967 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
5cfe86e6
HS
968 fi
969
df5e82b3
MT
970 buildinstaller
971 buildpackages
972 ;;
973shell)
974 # enter a shell inside LFS chroot
975 # may be used to changed kernel settings
976 prepareenv
977 entershell
978 ;;
979changelog)
d1dd6669 980 echo -n "Loading new Changelog from SVN: "
f9315063 981 svn log http://svn.ipfire.eu/svn/ipfire > doc/ChangeLog
d1dd6669 982 echo "Finished!"
df5e82b3
MT
983 ;;
984check)
985 echo "Checking sources files availability on the web"
986 if [ ! -d $DIR_CHK ]; then
987 mkdir -p $DIR_CHK
988 fi
989 FINISHED=0
990 cd $BASEDIR/lfs
991 for c in `seq $MAX_RETRIES`; do
992 if (( FINISHED==1 )); then
993 break
994 fi
995 FINISHED=1
996 cd $BASEDIR/lfs
997 for i in *; do
998 if [ -f "$i" -a "$i" != "Config" ]; then
999 make -s -f $i MACHINE=$MACHINE LFS_BASEDIR=$BASEDIR ROOT=$BASEDIR/build \
1000 MESSAGE="$i\t ($c/$MAX_RETRIES)" check
1001 if [ $? -ne 0 ]; then
1002 echo "Check : wget error in lfs/$i"
1003 FINISHED=0
1004 fi
1005 fi
1006 done
1007 done
1008 cd -
1009 ;;
1010checkclean)
1011 echo "Erasing sources files availability tags"
1012 rm -rf $DIR_CHK/*
1013 ;;
1014clean)
1015 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1016 $LOSETUP -d $i 2>/dev/null
1017 done
1018 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1019 umount $i
1020 done
1021 stdumount
1022 for i in `seq 0 7`; do
1023 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
1024 umount /dev/loop${i} 2>/dev/null;
1025 losetup -d /dev/loop${i} 2>/dev/null;
1026 fi;
1027 done
1028 rm -rf $BASEDIR/build
1029 rm -rf $BASEDIR/cdrom
f9315063 1030 rm -rf $BASEDIR/packages
df5e82b3 1031 rm -rf $BASEDIR/log
df5e82b3
MT
1032 if [ -h /tools ]; then
1033 rm -f /tools
1034 fi
1035 ;;
f8e5510c 1036newpak)
a9b17001
MT
1037 # create structure for a new package
1038 echo -e "Name of the new package: $2"
1039 if [ ! -f "lfs/$2" ]; then
1040 echo "`date -u '+%b %e %T'`: Creating directory src/paks/$2"
1041 mkdir -p src/paks/$2
1042 cd src/paks/$2
f8e5510c 1043 echo "`date -u '+%b %e %T'`: Creating files"
a9b17001
MT
1044 cp $BASEDIR/lfs/postfix $BASEDIR/lfs/$2
1045
f8e5510c 1046 touch ROOTFILES
f8e5510c 1047 touch {,un}install.sh
a9b17001 1048 ## install.sh
f8e5510c
MT
1049 echo '#!/bin/bash' > install.sh
1050 echo '#' >> install.sh
1051 echo '#################################################################' >> install.sh
1052 echo '# #' >> install.sh
1053 echo '# This file belongs to IPFire Firewall - GPLv2 - www.ipfire.org #' >> install.sh
1054 echo '# #' >> install.sh
1055 echo '#################################################################' >> install.sh
1056 echo '#' >> install.sh
1057 echo '# Extract the files' >> install.sh
1058 echo 'tar xfz files.tgz -C /' >> install.sh
a9b17001
MT
1059 echo 'cp -f ROOTFILES /opt/pakfire/installed/ROOTFILES.$2' >> install.sh
1060 ## uninstall.sh
f8e5510c
MT
1061 echo '#!/bin/bash' > uninstall.sh
1062 echo '#################################################################' >> uninstall.sh
1063 echo '# #' >> uninstall.sh
1064 echo '# This file belongs to IPFire Firewall - GPLv2 - www.ipfire.org #' >> uninstall.sh
1065 echo '# #' >> uninstall.sh
1066 echo '#################################################################' >> uninstall.sh
1067 echo '#' >> uninstall.sh
1068 echo '# Delete the files' >> uninstall.sh
1069 echo '## Befehl fehlt noch' >> uninstall.sh
a9b17001 1070 echo 'rm -f /opt/pakfire/installed/ROOTFILES.$2' >> uninstall.sh
f8e5510c 1071 echo "`date -u '+%b %e %T'`: Adding files to SVN"
a9b17001
MT
1072 cd - && svn add lfs/$2 && svn add src/paks/$2
1073
1074 echo -n "Do you want to remove the folders? [y/n]"
1075 read REM
1076 if [ "$REM" == "y" ]; then
1077 echo "Removing the folders..."
1078 svn del src/paks/$2 --force
1079 else
1080 echo "Folders are kept."
1081 fi
df5e82b3 1082 else
a9b17001 1083 echo "$2 already exists"
df5e82b3 1084 fi
df5e82b3
MT
1085 exit 0
1086 ;;
1087prefetch)
1088 if [ ! -d $BASEDIR/cache ]; then
1089 mkdir $BASEDIR/cache
1090 fi
1091 mkdir -p $BASEDIR/log
1092 echo "`date -u '+%b %e %T'`:Preload all source files" | tee -a $LOGFILE
1093 FINISHED=0
1094 cd $BASEDIR/lfs
1095 for c in `seq $MAX_RETRIES`; do
1096 if (( FINISHED==1 )); then
1097 break
1098 fi
1099 FINISHED=1
1100 cd $BASEDIR/lfs
1101 for i in *; do
1102 if [ -f "$i" -a "$i" != "Config" ]; then
1103 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
1104 if [ $? -ne 0 ]; then
1105 echo "Prefetch : wget error in lfs/$i"
1106 FINISHED=0
1107 else
1108 if [ $c -eq 1 ]; then
1109 echo "Prefetch : lfs/$i files loaded"
1110 fi
1111 fi
1112 fi
1113 done
1114 done
1115 echo "Prefetch : verifying md5sum"
1116 ERROR=0
1117 for i in *; do
1118 if [ -f "$i" -a "$i" != "Config" ]; then
1119 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
1120 if [ $? -ne 0 ]; then
1121 echo "md5 difference in lfs/$i"
1122 ERROR=1
1123 fi
1124 fi
1125 done
1126 if [ $ERROR -eq 0 ]; then
1127 echo "Prefetch : all files md5sum match"
1128 fi
1129 cd -
1130 ;;
df5e82b3
MT
1131toolchain)
1132 prepareenv
1133 buildtoolchain
1134 BUILDMACHINE=`uname -m`
1135 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
712d859c
MT
1136 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
1137 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
df5e82b3
MT
1138 build/{bin,etc,usr/bin,usr/local} \
1139 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
1140 log >> $LOGFILE
712d859c
MT
1141 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
1142 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
df5e82b3
MT
1143 stdumount
1144 ;;
1145gettoolchain)
1146 BUILDMACHINE=`uname -m`
1147 # arbitrary name to be updated in case of new toolchain package upload
c6cb9d25 1148 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
712d859c
MT
1149 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
1150 URL_IPFIRE=`grep URL_IPFIRE lfs/Config | awk '{ print $3 }'`
1151 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
1152 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
1153 cd $BASEDIR/cache/toolchains
1154 wget $URL_IPFIRE/toolchains/$PACKAGE.tar.gz $URL_IPFIRE/toolchains/$PACKAGE.md5 >& /dev/null
1155 if [ $? -ne 0 ]; then
1156 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
40a4ea4c 1157 else
712d859c
MT
1158 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
1159 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1160 else
1161 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1162 fi
40a4ea4c 1163 fi
712d859c
MT
1164 else
1165 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
1166 fi
1167 ;;
ce56e927
MT
1168sources-iso)
1169 prepareenv
1170 echo "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
1171 chroot $LFS /tools/bin/env -i HOME=/root \
1172 TERM=$TERM PS1='\u:\w\$ ' \
1173 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
1174 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
1175 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
1176 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
1177 stdumount
1178 ;;
c6cb9d25
MT
1179svn)
1180 case "$2" in
1181 update|up)
cc0e56be 1182 # clear
028698e8
MT
1183 echo "Loading the latest source files..."
1184 svn update | tee -a $PWD/log/_build.svn.update.log
c6cb9d25 1185 if [ $? -eq 0 ]; then
028698e8 1186 echo "Finished!"
c6cb9d25 1187 else
028698e8 1188 echo "Failure!"
c6cb9d25
MT
1189 exit 1
1190 fi
028698e8 1191 echo -n "Writing the svn-info to a file..."
c6cb9d25
MT
1192 svn info > $PWD/svn_status
1193 if [ "$?" -eq "0" ]; then
028698e8 1194 echo ".Finished!"
c6cb9d25 1195 else
028698e8 1196 echo ".Failure!"
c6cb9d25
MT
1197 exit 1
1198 fi
712d859c 1199 chmod 755 $0
cc0e56be 1200 exit 0
c6cb9d25
MT
1201 ;;
1202 commit|ci)
1203 clear
d79b46cb 1204 if [ -e /sbin/yast ]; then
028698e8
MT
1205 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
1206 $0 changelog
1207 fi
d79b46cb
MT
1208 fi
1209 echo "Upload the changed files..."
c6cb9d25 1210 sleep 1
d79b46cb
MT
1211 IPFIRE_SVN_MESSAGE=/tmp/ipfire-svn-co-message.txt
1212 rm -f $IPFIRE_SVN_MESSAGE
1213 mcedit $IPFIRE_SVN_MESSAGE
1214 svn commit -F $IPFIRE_SVN_MESSAGE
1215 rm -f $IPFIRE_SVN_MESSAGE
c6cb9d25
MT
1216 $0 svn up
1217 ;;
1218 dist)
a7fb5630 1219 #$0 svn up
c6cb9d25
MT
1220 echo -ne "Download source package from svn..."
1221 svn export http://svn.ipfire.eu/svn/ipfire ipfire-source/ --force > /dev/null
1222 if [ "$?" -eq "0" ]; then
1223 echo ".Done!"
1224 else
1225 echo ".Fail!"
1226 exit 1
1227 fi
1228 echo -n "Compress files..."
9dc02b38 1229 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
c6cb9d25
MT
1230 if [ "$?" -eq "0" ]; then
1231 echo ".Done!"
1232 else
1233 echo ".Fail!"
1234 exit 1
1235 fi
1236 echo -n "Cleanup..."
1237 rm ipfire-source/ -r
1238 if [ "$?" -eq "0" ]; then
1239 echo ".Done!"
1240 else
1241 echo ".Fail!"
1242 exit 1
1243 fi
1244 ;;
028698e8 1245 diff|di)
c6cb9d25
MT
1246 echo -ne "Make a local diff to last svn revision..."
1247 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
1248 if [ "$?" -eq "0" ]; then
1249 echo ".Done!"
1250 else
1251 echo ".Fail!"
1252 exit 1
1253 fi
1254 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
1255 ;;
1256 esac
f9315063 1257 ;;
cc0e56be
MT
1258make-config)
1259 echo -e "This is for creating your configuration..."
cc0e56be
MT
1260 echo -e "We will need some input:"
1261 echo -e ""
1262 echo -n "FTP-DOMAIN FOR THE ISO: "
1263 read IPFIRE_FTP_URL_EXT
1264 echo -n "PATH FOR $IPFIRE_FTP_URL_EXT: "
1265 read IPFIRE_FTP_PATH_EXT
1266 echo -n "USERNAME FOR $IPFIRE_FTP_URL_EXT: "
1267 read IPFIRE_FTP_USER_EXT
1268 echo -n "PASSWORD FOR $IPFIRE_FTP_URL_EXT: "
712d859c 1269 read -s IPFIRE_FTP_PASS_EXT
cc0e56be
MT
1270 echo ""
1271 echo "(You can leave this empty if the cache-server is the same as your iso-server.)"
1272 echo -n "FTP-DOMAIN FOR THE CACHE: "
1273 read IPFIRE_FTP_URL_INT
1274 echo -n "PATH FOR $IPFIRE_FTP_URL_INT: "
1275 read IPFIRE_FTP_PATH_INT
1276 if [ $IPFIRE_FTP_URL_INT ]; then
1277 echo -n "USERNAME FOR $IPFIRE_FTP_URL_INT: "
1278 read IPFIRE_FTP_USER_INT
1279 echo -n "PASSWORD FOR $IPFIRE_FTP_URL_INT: "
712d859c 1280 read -s IPFIRE_FTP_PASS_INT
cc0e56be
MT
1281 else
1282 IPFIRE_FTP_URL_INT=$IPFIRE_FTP_URL_EXT
1283 IPFIRE_FTP_USER_INT=$IPFIRE_FTP_USER_EXT
1284 IPFIRE_FTP_PASS_INT=$IPFIRE_FTP_PASS_EXT
1285 echo "USERNAME FOR $IPFIRE_FTP_URL_INT: $IPFIRE_FTP_USER_INT"
712d859c 1286 echo "PASSWORD FOR $IPFIRE_FTP_URL_INT: !HIDDEN!"
cc0e56be
MT
1287 fi
1288 echo ""
1289 echo "(You can leave this empty if the pak-server is the same as your iso-server.)"
1290 echo -n "FTP-DOMAIN FOR THE PAKS: "
1291 read IPFIRE_FTP_URL_PAK
1292 echo -n "PATH FOR $IPFIRE_FTP_URL_PAK: "
1293 read IPFIRE_FTP_PATH_PAK
1294 if [ $IPFIRE_FTP_URL_PAK ]; then
1295 echo -n "USERNAME FOR $IPFIRE_FTP_URL_PAK: "
1296 read IPFIRE_FTP_USER_PAK
1297 echo -n "PASSWORD FOR $IPFIRE_FTP_URL_PAK: "
712d859c 1298 read -s IPFIRE_FTP_PASS_PAK
a68fedca 1299 else
cc0e56be
MT
1300 IPFIRE_FTP_URL_PAK=$IPFIRE_FTP_URL_EXT
1301 IPFIRE_FTP_USER_PAK=$IPFIRE_FTP_USER_EXT
1302 IPFIRE_FTP_PASS_PAK=$IPFIRE_FTP_PASS_EXT
1303 echo "USERNAME FOR $IPFIRE_FTP_URL_PAK: $IPFIRE_FTP_USER_PAK"
712d859c 1304 echo "PASSWORD FOR $IPFIRE_FTP_URL_PAK: !HIDDEN!"
a68fedca 1305 fi
cc0e56be
MT
1306 echo ""
1307 echo -e "ONE OR MORE EMAIL ADDRESS(ES) TO WHICH THE REPORTS WILL BE SENT"
1308 echo -e "(seperated by comma)"
1309 read IPFIRE_MAIL_REPORT
1310 echo -n "EMAIL FROM: "
1311 read IPFIRE_MAIL_FROM
1312 echo -n "EMAIL SERVER: "
1313 read IPFIRE_MAIL_SERVER
1314 echo -n "LOGIN TO MAIL SERVER: "
1315 read IPFIRE_MAIL_USER
1316 echo -n "MAIL PASSWORD: "
712d859c 1317 read -s IPFIRE_MAIL_PASS
cc0e56be
MT
1318 echo -n "Saving..."
1319 for i in `seq 20`; do
1320 sleep 0.1; echo -n "."
1321 done
1322 echo ".Finished!"
1323 cat <<END > .config
1324### ISO server
1325IPFIRE_FTP_URL_EXT=$IPFIRE_FTP_URL_EXT
1326IPFIRE_FTP_PATH_EXT=$IPFIRE_FTP_PATH_EXT
1327IPFIRE_FTP_USER_EXT=$IPFIRE_FTP_USER_EXT
1328IPFIRE_FTP_PASS_EXT=$IPFIRE_FTP_PASS_EXT
1329### cache server
1330IPFIRE_FTP_URL_INT=$IPFIRE_FTP_URL_INT
1331IPFIRE_FTP_PATH_INT=$IPFIRE_FTP_PATH_INT
1332IPFIRE_FTP_USER_INT=$IPFIRE_FTP_USER_INT
1333IPFIRE_FTP_PASS_INT=$IPFIRE_FTP_PASS_INT
1334### paks server
1335IPFIRE_FTP_URL_PAK=$IPFIRE_FTP_URL_PAK
1336IPFIRE_FTP_PATH_PAK=$IPFIRE_FTP_PATH_PAK
1337IPFIRE_FTP_USER_PAK=$IPFIRE_FTP_USER_PAK
1338IPFIRE_FTP_PASS_PAK=$IPFIRE_FTP_PASS_PAK
1339### mail reports
1340IPFIRE_MAIL_REPORT=$IPFIRE_MAIL_REPORT
1341IPFIRE_MAIL_FROM=$IPFIRE_MAIL_FROM
1342IPFIRE_MAIL_SERVER=$IPFIRE_MAIL_SERVER
1343IPFIRE_MAIL_USER=$IPFIRE_MAIL_USER
1344IPFIRE_MAIL_PASS=$IPFIRE_MAIL_PASS
1345END
1346 ;;
1347sync)
1348 echo -e "Syncing cache to ftp:"
ce56e927 1349# rm -f doc/packages-to-remove-from-ftp
cc0e56be 1350 ncftpls -u $IPFIRE_FTP_USER_INT -p $IPFIRE_FTP_PASS_INT ftp://$IPFIRE_FTP_URL_INT$IPFIRE_FTP_PATH_INT/ > ftplist
0eab8e84
MT
1351 for i in `ls -w1 cache/`; do
1352 grep $i ftplist
1353 if [ "$?" -ne "0" ]; then
cc0e56be 1354 ncftpput -u $IPFIRE_FTP_USER_INT -p $IPFIRE_FTP_PASS_INT $IPFIRE_FTP_URL_INT $IPFIRE_FTP_PATH_INT/ cache/$i
0eab8e84
MT
1355 if [ "$?" -eq "0" ]; then
1356 echo -e "$i was successfully uploaded to the ftp server."
1357 else
1358 echo -e "There was an error while uploading $i to the ftp server."
1359 fi
1360 fi
1361 done
ce56e927
MT
1362# for i in `cat ftplist`; do
1363# ls -w1 cache/ | grep $i
1364# if [ "$?" -eq "1" ]; then
1365# echo $i | grep -v toolchain >> doc/packages-to-remove-from-ftp
1366# fi
1367# done
0eab8e84
MT
1368 rm -f ftplist
1369 ;;
cc0e56be
MT
1370upload)
1371 case "$2" in
1372 iso)
1373 echo -e "Uploading the iso to $IPFIRE_FTP_URL_EXT."
9dc02b38
MT
1374 cat <<EOF > .ftp-commands
1375mkdir $IPFIRE_FTP_PATH_EXT
1376ls -lah
1377quit
1378EOF
1379 ncftp -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT < .ftp-commands
1380 rm -f .ftp-commands
1381 md5sum ipfire-install-$VERSION.i386.iso > ipfire-install-$VERSION.i386.iso.md5
1382 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ ipfire-install-$VERSION.i386.iso
1383 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ ipfire-install-$VERSION.i386.iso.md5
1384 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ ipfire-source-r$SVN_REVISION.tar.gz
6aae8d61 1385 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ svn_status
9dc02b38
MT
1386 if [ "$?" -eq "0" ]; then
1387 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $IPFIRE_FTP_URL_EXT$IPFIRE_FTP_PATH_EXT/."
cc0e56be 1388 else
9dc02b38
MT
1389 echo -e "There was an error while uploading the iso to the ftp server."
1390 exit 1
cc0e56be 1391 fi
6aae8d61
MT
1392 if [ "$3" = "--with-sources-cd" ]; then
1393 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ ipfire-sources-cd-$VERSION.$MACHINE.iso
1394 fi
cc0e56be
MT
1395 ;;
1396 paks)
9dc02b38
MT
1397 cat <<EOF > .ftp-commands
1398mkdir $IPFIRE_FTP_PATH_PAK
1399ls -lah
1400quit
1401EOF
1402 ncftp -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK < .ftp-commands
1403 rm -f .ftp-commands
cc0e56be
MT
1404 ncftpput -z -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK $IPFIRE_FTP_PATH_PAK/ packages/*
1405 if [ "$?" -eq "0" ]; then
9dc02b38 1406 echo -e "The packages were successfully uploaded to $IPFIRE_FTP_URL_PAK$IPFIRE_FTP_PATH_PAK/."
cc0e56be
MT
1407 else
1408 echo -e "There was an error while uploading the packages to the ftp server."
712d859c 1409 exit 1
cc0e56be
MT
1410 fi
1411 ;;
1412 esac
0d0521b6 1413 ;;
52345790
MT
1414build-only)
1415 rm -f $BASEDIR/log/$2*
1416 BUILDMACHINE=`uname -m`
1417 prepareenv
1418 ipcopmake $2
1419 ;;
c6cb9d25
MT
1420build-silent)
1421 screen -dmS ipfire $0 build
1422 echo "Build started... This will take a while!"
1423 echo "You can see the status with 'screen -x ipfire'."
1424 ;;
cc0e56be
MT
1425mail)
1426 chmod 755 tools/sendEmail
1427 ATTACHMENT=/tmp/ipfire-build-logs-R$SVN_REVISION.tar.gz
1428 if [ "$2" = "ERROR" ]; then
1429 SUBJECT="ERROR: IPFIRE-BUILD R$SVN_REVISION on `hostname`"
1430 echo "ERROR: $0 build!"
1431 cat <<END > /tmp/ipfire_mail_body
1432When I was building IPFire on `hostname`, I have found an ERROR!
1433Here you can see the logs and detect the reason for this error.
1434
1435Best Regards
1436Your IPFire-Build-Script
1437END
1438 fi
1439 if [ "$2" = "SUCCESS" ]; then
1440 SUBJECT="SUCCESS: IPFIRE-BUILD R$SVN_REVISION on `hostname`"
1441 cat <<END > /tmp/ipfire_mail_body
1442Building IPFire on `hostname` in Revision $SVN_REVISION was successfull!
1443You can find the ISO on your ftp server.
1444
1445Statistics:
1446-----------
1447Started: $IPFIRE_START_TIME
1448Finished: `date`
1449
1450Best Regards
1451Your IPFire-Build-Script
1452END
1453 fi
1454 if [ "$2" = "SVNUPDATE" ]; then
1455 SUBJECT="SVNUPDATE: IPFIRE-BUILD R$SVN_REVISION on `hostname`"
1456 echo "ERROR: $0 svn up!"
1457 cat <<END > /tmp/ipfire_mail_body
1458When I was downloading the latest svn source,
1459I have found an ERROR!
1460Here you can see the logs and detect the reason for this error.
1461
1462Best Regards
1463Your IPFire-Build-Script
1464END
1465 fi
712d859c
MT
1466
1467 if [ "$2" = "SVNDIST" ]; then
1468 SUBJECT="SVNDIST: IPFIRE-BUILD R$SVN_REVISION on `hostname`"
1469 echo "ERROR: $0 svn dist!"
1470 cat <<END > /tmp/ipfire_mail_body
1471When I was exporting the latest svn source,
1472I have found an ERROR!
1473Here you can see the logs and detect the reason for this error.
1474
1475Best Regards
1476Your IPFire-Build-Script
1477END
1478 fi
1479
cc0e56be
MT
1480 if [ "$2" = "PREFETCH" ]; then
1481 SUBJECT="PREFETCH: IPFIRE-BUILD R$SVN_REVISION on `hostname`"
1482 echo "ERROR: $0 prefetch!"
1483 cat <<END > /tmp/ipfire_mail_body
1484When I was downloading the source packages,
1485I have found an ERROR!
1486Here you can see the logs and detect the reason for this error.
1487
1488Best Regards
1489Your IPFire-Build-Script
1490END
1491 fi
1492
1493 if [ "$2" = "ISO" ]; then
1494 SUBJECT="ISO: IPFIRE-BUILD R$SVN_REVISION on `hostname`"
1495 echo "ERROR: $0 upload iso!"
1496 cat <<END > /tmp/ipfire_mail_body
1497When I was uploading the iso image,
1498I have found an ERROR!
1499Here you can see the logs and detect the reason for this error.
1500
1501Best Regards
1502Your IPFire-Build-Script
1503END
1504 fi
1505
1506 if [ "$2" = "PAKS" ]; then
1507 SUBJECT="PAKS: IPFIRE-BUILD R$SVN_REVISION on `hostname`"
1508 echo "ERROR: $0 upload paks!"
1509 cat <<END > /tmp/ipfire_mail_body
1510When I was uploading the packages,
1511I have found an ERROR!
1512Here you can see the logs and detect the reason for this error.
1513
1514Best Regards
1515Your IPFire-Build-Script
1516END
1517 fi
1518
1519 tar cfz $ATTACHMENT log/_build*
1520 cat <<END >> /tmp/ipfire_mail_body
1521
1522Here is a summary... The full logs are in the attachment.
1523---------------------------------------------------------
1524
1525`tail log/_*`
1526END
1527 cat /tmp/ipfire_mail_body | tools/sendEmail -q \
1528 -f $IPFIRE_MAIL_FROM \
1529 -t $IPFIRE_MAIL_REPORT \
1530 -u $SUBJECT \
1531 -s $IPFIRE_MAIL_SERVER:25 \
1532 -xu $IPFIRE_MAIL_USER \
1533 -xp $IPFIRE_MAIL_PASS \
1534 -l log/_build.mail.log \
1535 -a $ATTACHMENT # -v
1536 rm -f /tmp/ipfire_mail_body $ATTACHMENT
1537 ;;
1538unattended)
712d859c
MT
1539 if [ ! -f .config ]; then
1540 echo "No configuration found. Try ./make.sh make-config."
1541 fi
cc0e56be
MT
1542 ### This is our procedure that will compile the IPFire by herself...
1543 echo "### UPDATE LOGS"
1544 update_logs
cc0e56be 1545
27ac55bf
MT
1546 if [ "$IPFIRE_REBUILD" -eq "0" ]; then
1547 echo "### SAVING TIME"
1548 export IPFIRE_START_TIME=`date`
ce56e927 1549
27ac55bf
MT
1550 echo "### GETTING TOOLCHAIN"
1551 $0 gettoolchain
1552
1553 echo "### RUNNING SVN-UPDATE"
1554 $0 svn update
1555 if [ $? -ne 0 ]; then
1556 $0 mail SVNUPDATE
1557 exit 1
1558 fi
712d859c 1559
27ac55bf
MT
1560 echo "### EXPORT SOURCES"
1561 $0 svn dist
1562 if [ $? -ne 0 ]; then
1563 $0 mail SVNDIST
1564 exit 1
1565 fi
cc0e56be 1566
27ac55bf
MT
1567 echo "### RUNNING PREFETCH"
1568 $0 prefetch | grep -q "md5 difference"
1569 if [ $? -eq 0 ]; then
1570 $0 mail PREFETCH
1571 exit 1
1572 fi
cc0e56be
MT
1573 fi
1574
1575 echo "### RUNNING BUILD"
1576 $0 build
1577 if [ $? -ne 0 ]; then
1578 $0 mail ERROR
1579 exit 1
1580 fi
1581
ce56e927 1582 echo "### MAKING SOURCES-ISO"
92b5fba4
MT
1583 echo "DISABLED by Delaco!"
1584 #$0 sources-iso
ce56e927 1585
cc0e56be
MT
1586 echo "### UPLOADING ISO"
1587 $0 upload iso
1588 if [ $? -ne 0 ]; then
1589 $0 mail ISO
1590 exit 1
1591 fi
1592
1593 echo "### UPLOADING PAKS"
1594 $0 upload paks
1595 if [ $? -ne 0 ]; then
1596 $0 mail PAKS
1597 exit 1
1598 fi
1599
1600 echo "### SUCCESS!"
1601 $0 mail SUCCESS
712d859c 1602 exit 0
cc0e56be
MT
1603 ;;
1604batch)
27ac55bf 1605 if [ `screen -ls | grep -q ipfire` ]; then
712d859c
MT
1606 echo "Build is already running, sorry!"
1607 exit 1
1608 else
27ac55bf
MT
1609 if [ "$2" = "--rebuild" ]; then
1610 export IPFIRE_REBUILD=1
1611 echo "REBUILD!"
1612 else
1613 export IPFIRE_REBUILD=0
1614 fi
712d859c
MT
1615 echo -n "IPFire-Batch-Build is starting..."
1616 screen -dmS ipfire $0 unattended
1617 if [ "$?" -eq "0" ]; then
1618 echo ".Done!"
1619 else
1620 echo ".ERROR!"
1621 exit 1
1622 fi
712d859c
MT
1623 exit 0
1624 fi
cc0e56be 1625 ;;
028698e8
MT
1626watch)
1627 echo "Exit with Ctrl+A, Ctrl+D."
1628 echo -n "Preparing..."
1629 for i in `seq 5`; do
1630 sleep 0.1; echo -n "."
1631 done
1632 echo ".Ready!"
1633 sleep 0.3
1634 screen -x ipfire
1635 ;;
df5e82b3 1636*)
24a4a744
MT
1637 clear
1638 svn info
712d859c 1639 select name in "Exit" "IPFIRE: Prefetch" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
24a4a744
MT
1640 do
1641 case $name in
c6cb9d25
MT
1642 "IPFIRE: Prefetch")
1643 $0 prefetch
1644 ;;
1645 "IPFIRE: Build (silent)")
1646 $0 build-silent
1647 ;;
1648 "IPFIRE: Watch Build")
028698e8 1649 $0 watch
c6cb9d25 1650 ;;
712d859c
MT
1651 "IPFIRE: Batch")
1652 $0 batch
1653 ;;
c6cb9d25
MT
1654 "IPFIRE: Clean")
1655 $0 clean
1656 ;;
1657 "SVN: Commit")
d63e8889
RZ
1658 echo "Are your sure to Update all Files to the Server (write: yes)?"; read input
1659 if [ "$input" == "yes" ]; then
1660 $0 svn commit
1661 fi
d1b6aa72 1662 $0 sync
c6cb9d25
MT
1663 ;;
1664 "SVN: Update")
1665 $0 svn update
1666 ;;
1667 "SVN: Status")
1668 svn status # | grep -v ^?
1669 ;;
1670 "SVN: Diff")
1671 $0 svn diff
1672 ;;
1673 "Help")
1674 echo "Usage: $0 {build|changelog|check|checkclean|clean|gettoolchain|newpak|prefetch|shell|sync|toolchain}"
1675 cat doc/make.sh-usage
1676 ;;
712d859c
MT
1677 "LOG: Tail")
1678 tail -f log/_*
1679 ;;
c6cb9d25
MT
1680 "Exit")
1681 break
1682 ;;
24a4a744
MT
1683 esac
1684 done
df5e82b3 1685 ;;
3ea75603 1686esac